unit TextDem;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, WinXtext, ExtCtrls;

type
  TForm1 = class(TForm)
    Text3D1: TText3D;
    PlaneFrame: TText3D;
    IndentFrame: TText3D;
    SunkenFrame: TText3D;
    PictureFrame: TText3D;
    SharpFrame: TText3D;
    OutdentFrame: TText3D;
    RaisedFrame: TText3D;
    FrameFrame: TText3D;
    Text3D10: TText3D;
    StopGo: TText3D;
    FrameColorCombo: TComboBox;
    ShadowCheck: TCheckBox;
    TextOnFrameCheck: TCheckBox;
    Text3D12: TText3D;
    Text3D13: TText3D;
    CloseButton: TButton;
    Text3D2: TText3D;
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure FrameColorComboChange(Sender: TObject);
    procedure ShadowCheckClick(Sender: TObject);
    procedure TextOnFrameCheckClick(Sender: TObject);
    procedure StopGoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StopGoMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormActivate(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  intTime: integer;

implementation

{$R *.DFM}

procedure TForm1.Timer1Timer(Sender: TObject);
var strTime: string;
begin
    intTime := intTime + 1;
    If intTime >= 10 Then intTime := 0;
    strTime := IntToStr(intTime);

    PlaneFrame.FrameStyle := 1 + intTime;
    PlaneFrame.Text := 'Plane' + strTime;

    IndentFrame.FrameStyle := 11 + intTime;
    IndentFrame.Text := 'Indent' + strTime;

    OutdentFrame.FrameStyle := 21 + intTime;
    OutdentFrame.Text := 'Outdent' + strTime;

    SunkenFrame.FrameStyle := 31 + intTime;
    SunkenFrame.Text := 'Sunken' + strTime;

    RaisedFrame.FrameStyle := 41 + intTime;
    RaisedFrame.Text := 'Raised' + strTime;

    PictureFrame.FrameStyle := 51 + intTime;
    PictureFrame.Text := 'Picture' + strTime;

    FrameFrame.FrameStyle := 61 + intTime;
    FrameFrame.Text := 'Frame' + strTime;

    SharpFrame.FrameStyle := 71 + intTime;
    SharpFrame.Text := 'Sharp' + strTime;
end;

procedure TForm1.FrameColorComboChange(Sender: TObject);
begin
    PlaneFrame.FrameColor := FrameColorCombo.ItemIndex;
    IndentFrame.FrameColor := FrameColorCombo.ItemIndex;
    OutdentFrame.FrameColor := FrameColorCombo.ItemIndex;
    SunkenFrame.FrameColor := FrameColorCombo.ItemIndex;
    RaisedFrame.FrameColor := FrameColorCombo.ItemIndex;
    PictureFrame.FrameColor := FrameColorCombo.ItemIndex;
    FrameFrame.FrameColor := FrameColorCombo.ItemIndex;
    SharpFrame.FrameColor := FrameColorCombo.ItemIndex;
end;

procedure TForm1.ShadowCheckClick(Sender: TObject);
begin
    PlaneFrame.FrameShadow := ShadowCheck.Checked;
    IndentFrame.FrameShadow := ShadowCheck.Checked;
    OutdentFrame.FrameShadow := ShadowCheck.Checked;
    SunkenFrame.FrameShadow := ShadowCheck.Checked;
    RaisedFrame.FrameShadow := ShadowCheck.Checked;
    PictureFrame.FrameShadow := ShadowCheck.Checked;
    FrameFrame.FrameShadow := ShadowCheck.Checked;
    SharpFrame.FrameShadow := ShadowCheck.Checked;
end;

procedure TForm1.TextOnFrameCheckClick(Sender: TObject);
begin
    PlaneFrame.TextOnFrame := TextOnFrameCheck.Checked;
    IndentFrame.TextOnFrame := TextOnFrameCheck.Checked;
    OutdentFrame.TextOnFrame := TextOnFrameCheck.Checked;
    SunkenFrame.TextOnFrame := TextOnFrameCheck.Checked;
    RaisedFrame.TextOnFrame := TextOnFrameCheck.Checked;
    PictureFrame.TextOnFrame := TextOnFrameCheck.Checked;
    FrameFrame.TextOnFrame := TextOnFrameCheck.Checked;
    SharpFrame.TextOnFrame := TextOnFrameCheck.Checked;
end;

procedure TForm1.StopGoMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    StopGo.FrameStyle := 39;
    StopGo.ForeColor := RGB(192, 192, 192);
    StopGo.HighlightColor := RGB(0, 0, 0);
end;

procedure TForm1.StopGoMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var stopTime: Boolean;
begin
    stopTime := Timer1.Enabled;
    Timer1.Enabled := Not stopTime;

    StopGo.FrameStyle := 49;
    StopGo.ForeColor := RGB(0, 0, 0);
    StopGo.HighlightColor := RGB(255, 255, 255);
    If stopTime Then
    begin
        StopGo.Text := 'Go';
        StopGo.BackColor := RGB(255, 0, 255);
    end
    Else
    begin
        StopGo.Text := 'Stop';
        StopGo.BackColor := RGB(255, 0, 0);
    end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
     FrameColorCombo.ItemIndex := 0;
end;

procedure TForm1.CloseButtonClick(Sender: TObject);
begin
     Close
end;

end.
